require "src/vector"
Triangle = {}

function Triangle.new(vectors, col)
    local ins = {
    }
    ins.vectors = vectors
    if col == nil then ins.col = {1, 1, 1}
    else ins.color = col end
    return ins 
end

function  Triangle.clipAgainstPlane(plane_p, plane_n, triangle_in)
    plane_n = Vector.norm(plane_n)
    local function dist(p)
        p = Vector.norm(p)
        return (plane_n.x * p.x + plane_n.y * p.y + plane_n.z * p.z - Vector.dotProduct(plane_n, plane_p) )
    end
    local insidePoint = {{Vector.new(0, 0, 0), Vector.new(0, 0, 0), Vector.new(0, 0, 0)}}; local insideCount = 0
    local outsidePoint = {{Vector.new(0, 0, 0), Vector.new(0, 0, 0), Vector.new(0, 0, 0)}}; local outsideCount = 0
    local d0 = dist(triangle_in.vectors[1])
    local d1 = dist(triangle_in.vectors[2])
    local d2 = dist(triangle_in.vectors[3])
    if d0 > 0 or d0 == 0 then  insideCount = insideCount +1  insidePoint[insideCount] = triangle_in.vectors[1]
    else  outsideCount = outsideCount +1  outsidePoint[outsideCount] = triangle_in.vectors[1] end
    if d1 > 0 or d1 == 0 then  insideCount = insideCount +1  insidePoint[insideCount] = triangle_in.vectors[2]
    else  outsideCount = outsideCount +1  outsidePoint[outsideCount] = triangle_in.vectors[2] end
    if d2 > 0 or d2 == 0 then  insideCount = insideCount +1  insidePoint[insideCount] = triangle_in.vectors[3]
    else  outsideCount = outsideCount +1  outsidePoint[outsideCount] = triangle_in.vectors[3] end
    if insideCount == 0 then 
        --the whole triangle is invisible, return do not render
        return {0}
    elseif insideCount == 3 then 
        --triangle is visible, render normally 
        return {1, triangle_in}
    elseif insideCount == 1 and outsideCount == 2 then 
        --clip triangle 
        local triangle_out = Triangle.new({{0, 0, 0},{0, 0, 0},{0, 0, 0}})
        triangle_out.vectors[1] = insidePoint[1]
        triangle_out.vectors[2] = Vector.intersectPlane(plane_p, plane_n, insidePoint[1], outsidePoint[1])
        triangle_out.vectors[3] = Vector.intersectPlane(plane_p, plane_n, insidePoint[1], outsidePoint[2])
        triangle_out.col = triangle_in.col
        return {2, triangle_out}
    elseif insideCount == 2 and outsideCount == 1 then 
        local triangle_out = Triangle.new({{0, 0,0},{0, 0, 0},{0, 0, 0}})
        local triangle_out2 =  Triangle.new({{0, 0,0},{0, 0, 0},{0, 0, 0}})

        triangle_out.vectors[1] = insidePoint[1]
        triangle_out.vectors[2] = insidePoint[2]
        triangle_out.vectors[3] = Vector.intersectPlane(plane_p, plane_n, insidePoint[1], outsidePoint[1])
        triangle_out.col =  triangle_in.col

        triangle_out2.vectors[1] = insidePoint[2]
        triangle_out2.vectors[2] = triangle_out.vectors[3]
        triangle_out2.vectors[3] = Vector.intersectPlane(plane_p, plane_n, insidePoint[2], outsidePoint[1])
        triangle_out2.col = triangle_in.col
        --return state 3 and the new triangles
        return {3, triangle_out2, triangle_out }
    end

end