Vector = {}

function Vector.new(x, y, z, w)
    local ins = {}
    ins.x = x 
    ins.y = y 
    ins.z = z
    if w == nil then ins.w = 1 else ins.w = w end
    return ins 
end
--adds two vectors
function Vector.add(vec1, vec2)
    return {x = vec1.x + vec2.x, y =vec1.y + vec2.y, z = vec1.z + vec2.z, w = Vector.length({x = vec1.x + vec2.x, y =vec1.y + vec2.y, z = vec1.z + vec2.z } ) } 
end

function  Vector.subtract(vec1, vec2)
    return {x = vec1.x - vec2.x, y =vec1.y - vec2.y, z = vec1.z - vec2.z, w = Vector.length({x = vec1.x - vec2.x, y =vec1.y - vec2.y, z = vec1.z - vec2.z } ) } 
end

function  Vector.mul(vec1, mult)
    return {x = vec1.x * mult, y =vec1.y *  mult, z = vec1.z *  mult, w = Vector.length(vec1)} 
end

function  Vector.div(vec1, d)
    return {x = vec1.x / d, y =vec1.y /  d, z = vec1.z /  d} 
end

function Vector.dotProduct(vec1, vec2)
    return vec1.x * vec2.x + vec1.y * vec2.y + vec1.z * vec2.z
end

function Vector.length(vec1)
    return math.sqrt(Vector.dotProduct(vec1, vec1))
end

function Vector.norm(vec1)
    local lenght = Vector.length(vec1)
    return{ x = vec1.x / lenght, y = vec1.y / lenght, z = vec1.z / lenght, w = lenght}
end

function Vector.crossProduct(vec1, vec2)
    local vecr = {x =0 , y=0, z=0}
    vecr.x = vec1.y * vec2.z - vec1.z * vec2.y 
    vecr.y = vec1.z * vec2.x - vec1.x * vec2.z 
    vecr.z = vec1.x * vec2.y - vec1.y * vec2.x
    return vecr
end

function  Vector.intersectPlane(plane_p, plane_n, linestart, lineend)
    plane_n = Vector.norm(plane_n)
    local plane_d = -Vector.dotProduct(plane_n, plane_p)
    local ad = Vector.dotProduct(linestart, plane_n)
    local bd = Vector.dotProduct(lineend, plane_n)
    local t = (-plane_d - ad) / (bd - ad)
    local linestartToEnd = Vector.subtract(lineend, linestart)
    local lineToIntersect = Vector.mul(linestartToEnd, t) 
    return Vector.add(linestart, lineToIntersect)
end


function Vector.inverse(vec1)
    return {x = vec1.x*-1, y = vec1.y *-1, z = vec1.z*-1, w = vec1.w}
end

function Vector.multiplyByMatrix(i ,matrix)
    local o = Vector.new(0, 0, 0, 0)
    o.x = i.x * matrix.m[1][1] + i.y * matrix.m[2][1] + i.z * matrix.m[3][1] + i.w * matrix.m[4][1]
    o.y = i.x * matrix.m[1][2] + i.y * matrix.m[2][2] + i.z * matrix.m[3][2] + i.w * matrix.m[4][2]
    o.z = i.x * matrix.m[1][3] + i.y * matrix.m[2][3] + i.z * matrix.m[3][3] + i.w * matrix.m[4][3]
    o.w = i.x * matrix.m[1][4] + i.y * matrix.m[2][4] + i.z * matrix.m[3][4] + i.w * matrix.m[4][4]
    return o
end
